program Mlaticka40;
uses crt, Dos;

const
  MaxPolozek = 200;
  VB = 30000;     {Velikost bufferu}
  Ctvercu = 15;   {pocet ctverecku v progress baru}

type
    DBFHlavicka = Record
                    Verze      : byte;
                    Rok        : byte;
                    Mesic      : byte;
                    Den        : byte;
                    Zaznamu    : longint;
                    AdresaDat  : word;
                    VelZaznamu : word;
                    Smeti      : array[1..20] of byte;
    end;

    DBFZaznam = Record
                    Jmeno      : array[1..11] of char;
                    Typ        : char;
                    Adr1       : longint;
                    Delka      : byte;
                    DesMist    : byte;
                    Zbytek     : array[1..14] of byte;
    end;

    Dvojka = record
                    Jedna : string[8];
                    Dve   : string[3];
                    Cesta : string;
    end;


var
    soubor2,
    soubor      : file;

    R, S,
    Faze,
    Znak        : byte;

    Precteno,
    Citac,
    Citac2,
    Citac3,
    Poli        : Integer;

    Size,
    Pocitadlo,
    Krok        : longint;

    Hlava       : DBFHlavicka;
    Policka     : array [1..MaxPolozek] of DBFZaznam;
    Vyhazov     : boolean;
    DirInfo     : SearchRec;
    Rozpad      : Dvojka;
    Buffer      : array [1..VB] of byte;
    pole        : array[0..255] of byte;
    Kolik       : word;

Procedure HideCursor;  assembler;
asm
  mov      ah,$01  { Function number }
  mov      ch,$20
  mov      cl,$00
  Int      $10     { Call BIOS }
end;  { HideCursor }


Procedure RestoreCursor;  assembler;
asm
  mov      ah,$01  { Function number }
  mov      ch,$06  { Starting scan line }
  mov      cl,$07  { Ending scan line }
  int      $10     { Call BIOS }
end; { RestoreCursor }

procedure DBF_Prevod;
var
   Citac2, citac : word;
begin
    Citac2 := 1;
    For citac := 1 to Precteno do
        if (not Vyhazov) or (Pole [Buffer[Citac]] <> 0) then
        begin
            Buffer[Citac2] := Pole[Buffer[Citac]];
            inc (Citac2);
        end;
    if Citac2 - 1 < Precteno then
        For Citac := 1 to Precteno - Citac2 - 1 do
        begin
            Buffer[Citac2] := 32;
            inc (Citac2);
        end;
end;

procedure DB_Pole;
var
   Citac : word;
   pom : byte;
begin
   For Citac := 1 to Poli do
   begin
       if Policka[Citac].Typ = 'C' then    {jestlize to je znakove pole}
       begin
           BlockRead(Soubor, Buffer, Policka[Citac].Delka, Precteno);
           DBF_Prevod;
           BlockWrite (Soubor2, Buffer, Policka[Citac].Delka, Precteno);
       end
       else
       begin
           BlockRead (Soubor, Buffer, Policka[Citac].Delka, Precteno);
           BlockWrite (Soubor2, Buffer, Policka[Citac].Delka, Precteno);
       end;
   end;
end;

procedure progress (Faze : word);
begin
   if Faze = 0 then
       Pocitadlo := 0
   else
   begin
       case Faze mod 40000 of
           10000 : begin
                       GotoXY (s, r);
                       write (#176);
                   end;
           20000 : begin
                       GotoXY (s, r);
                       write (#177);
                   end;
           30000 : begin
                       GotoXY (s, r);
                       write (#178);
                   end;
           0     : begin
                       GotoXY (s, r);
                       write (#219);
                   end;
       end;
       if Pocitadlo mod Krok = 0 then
       begin
           GotoXY (s,r);
           Write (#219);
           inc (S);
       end;
   end;
   inc(Pocitadlo)
end;

procedure Preved;
var citac : word;
    Vnejsi,
    Cyklu : word;
begin
   For Citac := 1 to Kolik do
   begin
       if (not Vyhazov) or (Pole[Buffer[Citac]] <> 0) then
           Buffer[Citac] := Pole[Buffer[Citac]];
       Progress(Citac);
   end;
end;

procedure Logo;
begin
   writeln;
   TextColor (Yellow);
   writeln('                          MLATICKA 4.2  (c)1997  2P ');
   TextColor (LightBlue);
   writeln('                       Prevod kodu z cehokoli na cokoli');
   TextColor (LightGray);
   writeln;
end;

procedure Help;
begin
    writeln('         Program MLATICKA nacte soubor1, ktery podle tabulky prevede do');
    writeln('                                   souboru2.');
    writeln;
    writeln('            Program MLATICKA slouzi k prevodu textu napr. v kodu latin2 do');
    writeln('      kodu  bri  Kamenickych  a naopak. Jedna se o univerzalni konvertor z');
    writeln('      cehokoli  na  cokoli.  Zalezi  jen na tabulkach, ktere si kazdy muze');
    writeln('      udelat sam.');
    writeln;
    writeln('            MLATICKA  sama  zkontroluje,  zda  vstupni soubor nema priponu');
    writeln('      DBF.   Tyto  soubory  prevadi  korektne,  tedy  nejdrive  zanalyzuje');
    writeln('      hlavicku a diky udajum, ktere jsou v ni obsazeny muze prevadet pouze');
    writeln('      polozky, ktere jsou typu text.');
    writeln;
    writeln('            Zvlastni typ tabulky je vyhazovaci tabulka, ktera je delsi nez');
    writeln('      256  bajtu.  Tato  tabulka  urcuje,  ktere  znaky  budou  na vystupu');
    writeln('      nahrazeny mezerou.');
    writeln;
    writeln('                  Seznam tabulek najdete v souboru SEZNAM.TXT.');
end;

procedure Strucne;
begin
   writeln;
   writeln('   Pouziti:  MLATICKA <soubor1> <soubor2> <tabulka>');
   writeln;
   writeln('   Eksampl:  MLATICKA latin2.txt kamenic.txt lat2kam.buf');
   writeln;
   writeln('soubor1...vstupni soubor');
   writeln('soubor2...vystupni soubor');
   writeln('tabulka...tabulka znaku');
   writeln('/?........help');
end;

function Otoc (vstup : string) : string;
var
   Citac : byte;
   Zatim : string;
begin
   Zatim := '';
   For Citac := length (Vstup) downto 1 do
         Zatim := Zatim + Vstup[Citac];
   Otoc := Zatim;
end;

procedure Rozloz (Fajlnejm : string; var Vystup : Dvojka);
var
   Citac   : byte;
   Lomitko,
   Pripona : boolean;
begin
   Pripona := False;
   Lomitko := False;
   Vystup.Jedna := '';
   Vystup.Dve   := '';
   Vystup.Cesta := '';
   for Citac := length (Fajlnejm) downto 1 do
   begin
       if Fajlnejm[Citac] = '\' then Lomitko := True;
       if (Pripona) and (Fajlnejm[Citac] <> '.') and (not (Lomitko)) then
           Vystup.Jedna := Vystup.Jedna + Fajlnejm[Citac];
       if (not Pripona) and (Fajlnejm[Citac] <> '.') and (not(Lomitko)) then
           Vystup.Dve := Vystup.Dve + Fajlnejm[Citac];
       if Lomitko then
           Vystup.Cesta := Vystup.Cesta + Fajlnejm[Citac];
       if Fajlnejm[Citac] = '.' then Pripona := True;
   end;
   Vystup.Jedna := Otoc (Vystup.Jedna);
   Vystup.Dve   := Otoc (Vystup.Dve);
   Vystup.Cesta := Otoc (Vystup.Cesta);
end;


(* Otevreni prevodni tabulky, nacteni tabulky do pole *)

procedure Tabule;
var
   Tabulka : file;
begin
{$I-}
    assign(tabulka, paramstr(3));
    reset(tabulka,1);
    if IOResult <> 0 then        {Jestli jsou potize ze souborem}
    begin
        Rozloz (paramstr(0), Rozpad);
        assign(tabulka, Rozpad.Cesta+paramstr(3));
        reset(tabulka,1);
        if IOResult <> 0 then        {Jestli jsou potize ze souborem}
        begin
            TextColor (LightRed);
            writeln ('Chyba pri otevirani souboru s tabulkou: ',paramstr(3));
            TextColor (LightGray);
            Close (Tabulka);
            Halt (1);
        end;
    end;
{$I+}
    if FileSize (Tabulka) > 256 Then Vyhazov := True;
    BlockRead(tabulka,pole,SizeOf(Pole)); {Nacti tabulku do pole}
    close(tabulka);
end;

procedure Nacti_Hlavu( var Kam : DBFHlavicka);
var
    Precteno : word;
begin
    BlockRead (Soubor, Kam, SizeOf(Kam), Precteno);
    {Kdyz nactu mene, nez je delka hlavicky}
    if Precteno < SizeOf(Kam) then
    begin
        TextColor (LightRed);
        writeln ('Chyba pri cteni hlavicky DBF souboru: ',paramstr(1));
        TextColor (LightGray);
        Close (Soubor);
        Close (Soubor2);
        Halt (1);
    end;
    {Kdyz je to DBF jine nez verze 3}
    if Kam.Verze <> 3 then
    begin
        TextColor (LightRed);
        writeln ('Neznama verze DBF souboru: ',paramstr(3));
        writeln ('Prevedu, ale za nic nerucim!');
        TextColor (LightGray);
    end;
end;

function Nacti_Pole : word;
var
   Precteno : word;
   Citac : word;
   Mezera : char;
begin
{Nacitani udaju o polich databaze}
    Citac := 1;
    Repeat
        BlockRead (Soubor, Policka[Citac], SizeOf(Policka[Citac]), Precteno);
        if Precteno < SizeOf(Policka[Citac]) then
        begin
            TextColor (LightRed);
            writeln ('Chyba pri cteni DBF souboru: ',paramstr(1));
            TextColor (LightGray);
            Close (Soubor);
            Close (Soubor2);
            Halt (1);
        end;
        BlockWrite (Soubor2, Policka[Citac], SizeOf(Policka[Citac]));
        Inc(Citac);
    Until (FilePos(Soubor)+32) > Hlava.AdresaDat;
    Nacti_Pole := Citac - 1;
    Mezera := ' ';
    for Citac := FilePos(Soubor2) to Hlava.AdresaDat-3 do
        Blockwrite (Soubor2, Mezera, 1);
end;

procedure Je_To_DBF;
begin
    Nacti_Hlavu(Hlava);        {Do recordu Hlava nactu hlavicku}
    BlockWrite (Soubor2, Hlava, SizeOf(Hlava));   {Hlavu zkopiruji}
    Poli := Nacti_Pole;   {Do pole policka najdu udaje o polich}
                                    {Pocet poli ulozim do Poli}
    Znak := 13;
    BlockWrite (Soubor2, Znak, 1);
    Znak := 0;
    BlockWrite (Soubor2, Znak, 1);
    Seek (Soubor, Hlava.AdresaDat);      {Cast s daty}
    Krok := Hlava.Zaznamu div Ctvercu;   {kolik je zaznamu na jeden ctverecek}

    for Citac := 1 to Ctvercu+1 do      {nakreslim prazdne ctverecky}
        write (#176);

    For Citac := 1 to Hlava.Zaznamu do   {Pro kazdy zaznam, delam prevod}
    begin
        DB_Pole;
        Blockread (Soubor, Buffer, 1);
        BlockWrite (Soubor2, Buffer, 1);
        Progress( Citac);
    end;
    GotoXY (s,r);
    Write (#219);
    inc (S);
    Znak := $1A;
    BlockWrite (Soubor2, Znak, 1);
end;

procedure Je_To_Text;
var
   Citac : byte;
begin
   {Nakreslim sede ctverecky, ktere se pak budou vybarvovat}
   {Spocitam, kolik bajtu je na jeden ctverecek}
    size := filesize(soubor);
    Krok := size div ctvercu;

    {Ted uz jenom smycka, ktera pise ctverecky}
    for Citac := 1 to Ctvercu+1 do
        write (#176);
    Kolik := VB;

    Repeat
        BlockRead (Soubor, Buffer, VB, Kolik);
        Preved;
        BlockWrite (Soubor2, Buffer, Kolik);
    until Kolik < VB;
end;


procedure trans (vstup, vystup : string);
begin
   assign(soubor,vstup);
   assign(soubor2,vystup);

   write(vstup, ' ');
   S := WhereX;
   R := WhereY;

   rewrite(soubor2, 1);
   reset(soubor, 1);

   if (Copy (paramstr(1),Length(paramstr(1))-2,3) = 'DBF') or
      (Copy (paramstr(1),Length(paramstr(1))-2,3) = 'dbf') then
       Je_To_DBF
   else
       Je_To_Text;
   close(soubor2);
   close(soubor);
   RestoreCursor;
end;

function Jak_Vystup (jmeno, maska : string ) : string;
var
   Prvni,
   Pripona,
   Prvni2,
   Pripona2,
   Cesta2   : string;
   Rozbor   : Dvojka;

begin
   Rozloz (Jmeno, Rozbor);

   Prvni := Rozbor.Jedna;
   Pripona := Rozbor.Dve;

   Rozloz (Maska, Rozbor);

   Prvni2 := Rozbor.Jedna;
   Pripona2 := Rozbor.Dve;
   Cesta2 := Rozbor.Cesta;

   if (Prvni2 = '*') or (Pripona2 = '*') then
   begin
          if Prvni2 = '*' then
                 Jak_Vystup := Cesta2+Prvni+'.'+Pripona2;
          if Pripona2 = '*' then
                 Jak_Vystup := Cesta2+Prvni2+'.'+Pripona;
   end
   else
          Jak_Vystup := Maska;
end;

begin
    Faze := 1;
    clrscr;
    HideCursor;
    Logo;
    if paramstr(1)='/?' then
    begin
        Help;
        halt;
    end;
    if (paramcount < 3) then
    begin
        Strucne;
        halt;
    end;
    Tabule;
    Rozloz (paramstr(1), Rozpad);
    findfirst (paramstr(1), AnyFile ,DirInfo);
    while DosError = 0 do
    begin
        Progress (0);
        Trans (Rozpad.Cesta+DirInfo.Name, Jak_Vystup(DirInfo.Name, paramstr(2)));
        FindNext(DirInfo);
        GotoXY (s,r);
        Writeln (#219);
    end;
end.